///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Google Image API - See description below
// Modified by Nataly Moreno
//
// Links to download libraries:
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////


//Google Image API
//
// GET GOOGLE IMAGES SEARCH RESULTS
//
// I use the ajax.googleapis.com json search results to fetch the image
// urls into a string array and display them one at a time
//
// Youssef Faltas, Feb 2014
//     From: http://www.openprocessing.org/sketch/132752
// With Modifications

JSONArray result;
JSONObject response;
PImage img = null;

int num = 0;

String GoogleImageSetup(String searchTerm)
{
  //link = img_url();      // returns an array of image url strings
  return img_url(searchTerm);
}

void drawImageFromGoogle(String searchTerm, String link, int rsize, float xp, float yp)
{
  img = loadImage(link, "jpg");
  img.resize(0, rsize);
  if(img != null)
  {
    stroke(0);
    fill(0);
    pushMatrix();
    translate(5,0);
    rect(xp - 5, yp - 5, img.width + 10, img.height + 10);    
    image(img, xp, yp, 
          img.width, img.height);
          
    drawColorBar(searchTerm, width - (width * margin) - 110, yp + (img.height / 2));
    popMatrix();
  }
  else
  {
    num++;
    link = img_url(searchTerm);
  }
}

String img_url(String searchTerm)
{
  String url, linky;
      
  searchTerm = searchTerm.replace(' ', '+');
  try {
    url = "https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q="+searchTerm+ "&start="+num+"&as_filetype=jpg"+"&imgsz=medium"; //ift:jpg,isz:m";
    
  //https://ajax.googleapis.com/ajax/services/search/images?v=1.0&q=Abert's+Towhee&start=4&as_filetype=jpg&imgsz=medium
              
  // find more search arguments here
  // https://developers.google.com/image-search/v1/jsondevguide#json_args
         
  response = loadJSONObject(url);
  response = response.getJSONObject("responseData");
  result = response.getJSONArray("results");
      
  JSONObject jresult = result.getJSONObject(0);
 
  int high = jresult.getInt("height");
  int wide = jresult.getInt("width");
  String linkstring = jresult.getString("unescapedUrl");
  linky = linkstring;
  }
  catch(java.lang.RuntimeException e)
  {
    num++;
    String nurl = img_url(searchTerm);
    return nurl;
  }

  return linky;
}











