///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 Assignment 4: Bird Migration Patterns Visualization
// Setup Code with all libraries
// by Nataly Moreno
//
// Links to download libraries:
//     ControlP5: http://www.sojamo.de/libraries/controlP5/#installation
//
///////////////////////////////////////////////////////////////////////////////////////////


//Data Collection Variables
Table myTable;
float multiplier = 10000.0;
ArrayList<String> BirdSpecies = new ArrayList<String>();

String[] months = { "January", "February", "March", "April", "May", "June", "July",
                    "August", "September", "October", "November", "December" };

String[] states = {"Alabama", "Alaska", "Arizona", "Arkansas", "California", "Colorado",
                   "Connecticut", "Delaware", "Florida", "Georgia", "Hawaii", "Idaho",
                   "Illinois", "Indiana", "Iowa", "Kansas", "Kentucky", "Louisiana",
                   "Maine", "Maryland", "Massachusetts", "Michigan", "Minnesota",
                   "Mississippi", "Missouri", "Montana", "Nebraska", "Nevada",
                   "New Hampshire", "New Jersey", "New Mexico", "New York", "North Carolina",
                   "North Dakota", "Ohio", "Oklahoma", "Oregon", "Pennsylvania", "Rhode Island",
                   "South Carolina", "South Dakota", "Tennessee", "Texas", "Utah", "Vermont",
                   "Virginia", "Washington", "West Virginia", "Wisconsin", "Wyoming"
                   };
           
int numRows, numColumns;
float maxBirdCount = 0;
float minBirdCount = 1;
float rawMin = 1;
float rawMax = 0;

//Class to Help Hold Data
public class Bird_Data {
  public ArrayList<String> bird_states = new ArrayList<String>();
  public ArrayList<ArrayList<Float>> weekly_bird_data = 
         new ArrayList<ArrayList<Float>>();
  
  public void set_bird_states(ArrayList<String> the_states)
  {
    bird_states = the_states;
  }
  public void append_to_bird_states(String bird_state)
  {
    bird_states.add(bird_state);
  }
  public void append_to_weekly_bird_data(ArrayList<Float> birdy_data)
  {
    weekly_bird_data.add(birdy_data);
  } 
}

//Data Structure to Hold Data
HashMap<String, Bird_Data> birdyData = new HashMap<String, Bird_Data>();   
     
void setup()
{
  size(1355, 970, P2D);
  smooth();
  frameRate(rate);
   
  if(frame != null)
    frame.setResizable(true);
  
  //Store CSV File
  myTable = loadTable("birdData.csv", "header");

  println(myTable.getRowCount());
  println(myTable.getColumnCount());
  for(int i = 0; i < myTable.getRowCount(); i++) //5
  {
    //Parse the Data from the CSV File
    String birdType = capitalizeFirstLetter(myTable.getString(i, 1));
    String inState  = capitalizeFirstLetter(myTable.getString(i, 0)); 
    ArrayList<Float> vectorFreq = new ArrayList<Float>();
    
    for(int j = 0; j < myTable.getColumnCount(); j++) //50
    {
      Float tempFloat = myTable.getFloat(i,j);
      
      if(!tempFloat.isNaN())
      {
        vectorFreq.add(tempFloat * multiplier);
        if( (tempFloat * multiplier) > maxBirdCount) 
          maxBirdCount = tempFloat * multiplier;
        if( ((tempFloat * multiplier) < minBirdCount) && tempFloat != 0.0)
          minBirdCount = tempFloat * multiplier;
        if( (tempFloat < rawMin) && tempFloat != 0.0)
          rawMin = tempFloat;
        if( (tempFloat > rawMax) && tempFloat != 0.0)
          rawMax = tempFloat;
      }
    }
    
    if(vectorFreq.size() != 48)
    {
      println("Error: Vector Frequency for bird: " + birdType + " and state: "
              + inState + " was not of length 48.");
    }
    
    //Store the Data from the CSV File
    if(birdyData.get(birdType) == null) //bird does not exist in the data structure
    {
      Bird_Data avianData = new Bird_Data();
      avianData.append_to_bird_states(inState);
      avianData.append_to_weekly_bird_data(vectorFreq);
      birdyData.put(birdType, avianData);
    }
    else //the bird exists, just add the data to it
    {
      Bird_Data avianData = birdyData.get(birdType);
      avianData.append_to_bird_states(inState);
      avianData.append_to_weekly_bird_data(vectorFreq);
    }
  }
  
  fillBirdSpeciesList();
  
  createColorsArray();
  //Set up Control P5
  //cp5Setup();
}

void fillBirdSpeciesList()
{
  for(Map.Entry aviEntry : birdyData.entrySet())
  {
    BirdSpecies.add((String)aviEntry.getKey());
  }
  
  java.util.Collections.sort(BirdSpecies);
  
  //printBirdSpecies();
}

//http://stackoverflow.com/questions/1149855/how-to-upper-case-every-first-letter-of-word-in-a-string
String capitalizeFirstLetter(String s)
{
  StringBuffer res = new StringBuffer();

  String[] strArr = s.split(" ");
  for (String str : strArr) 
  {
    char[] stringArray = str.trim().toCharArray();
    stringArray[0] = Character.toUpperCase(stringArray[0]);
    str = new String(stringArray);

    res.append(str).append(" ");
  }

  return res.toString().trim();
}
    
    























